Index: trunk/source/geometry/navigation/src/G4VoxelNavigation.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4VoxelNavigation.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4VoxelNavigation.cc	(revision 1347)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VoxelNavigation.cc,v 1.9 2008/11/14 18:26:35 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4VoxelNavigation.cc,v 1.13 2010/11/04 18:18:00 japost Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 //
@@ -37,4 +37,5 @@
 #include "G4VoxelNavigation.hh"
 #include "G4GeometryTolerance.hh"
+#include "G4VoxelSafety.hh"
 
 // ********************************************************************
@@ -43,5 +44,5 @@
 //
 G4VoxelNavigation::G4VoxelNavigation()
-  : fVoxelDepth(-1),
+  : fBList(), fVoxelDepth(-1),
     fVoxelAxisStack(kNavigatorVoxelStackMax,kXAxis),
     fVoxelNoSlicesStack(kNavigatorVoxelStackMax,0),
@@ -49,9 +50,8 @@
     fVoxelNodeNoStack(kNavigatorVoxelStackMax,0),
     fVoxelHeaderStack(kNavigatorVoxelStackMax,(G4SmartVoxelHeader*)0),
-    fVoxelNode(0),
-    fCheck(false),
-    fVerbose(0)
+    fVoxelNode(0), fpVoxelSafety(0), fCheck(false), fBestSafety(false)
 {
-  kCarTolerance = G4GeometryTolerance::GetInstance()->GetSurfaceTolerance();
+  fLogger = new G4NavigationLogger("G4VoxelNavigation");
+  fpVoxelSafety = new G4VoxelSafety (); 
 }
 
@@ -62,7 +62,6 @@
 G4VoxelNavigation::~G4VoxelNavigation()
 {
-#ifdef G4DEBUG_NAVIGATION
-  G4cout << "G4VoxelNavigation::~G4VoxelNavigation() called." << G4endl;
-#endif
+  delete fpVoxelSafety;
+  delete fLogger;
 }
 
@@ -110,45 +109,5 @@
   if ( fCheck )
   {
-    if(fVerbose == 1 )
-    {
-      G4cout << "*** G4VoxelNavigation::ComputeStep(): ***" << G4endl
-             << "    Invoked DistanceToOut(p) for mother solid: "
-             << motherSolid->GetName()
-             << ". Solid replied: " << motherSafety << G4endl
-             << "    For local point p: " << localPoint
-             << ", to be considered as 'mother safety'." << G4endl;
-    }
-    if( motherSafety < 0.0 )
-    {
-      G4cout << "ERROR - G4VoxelNavigation::ComputeStep()" << G4endl
-             << "        Current solid " << motherSolid->GetName()
-             << " gave negative safety: " << motherSafety << G4endl
-             << "        for the current (local) point " << localPoint
-             << G4endl;
-      motherSolid->DumpInfo();
-      G4Exception("G4VoxelNavigation::ComputeStep()",
-                  "NegativeSafetyMotherVol", FatalException,
-                  "Negative Safety In Voxel Navigation !" ); 
-    }
-    if( motherSolid->Inside(localPoint)==kOutside )
-    { 
-      G4cout << "WARNING - G4VoxelNavigation::ComputeStep()" << G4endl
-             << "          Point " << localPoint
-             << " is outside current volume " << motherPhysical->GetName()
-             << G4endl;
-      G4double  estDistToSolid= motherSolid->DistanceToIn(localPoint); 
-      G4cout << "          Estimated isotropic distance to solid (distToIn)= " 
-             << estDistToSolid << G4endl;
-      if( estDistToSolid > 100.0 * kCarTolerance )
-      {
-        motherSolid->DumpInfo();
-        G4Exception("G4VoxelNavigation::ComputeStep()",
-                    "FarOutsideCurrentVolume", FatalException,
-                    "Point is far outside Current Volume !"); 
-      }
-      else
-        G4Exception("G4VoxelNavigation::ComputeStep()", "OutsideCurrentVolume", 
-                    JustWarning, "Point is a little outside Current Volume."); 
-    }
+    fLogger->PreComputeStepLog (motherPhysical, motherSafety, localPoint);
   }
 #endif
@@ -204,12 +163,7 @@
                      sampleSolid->DistanceToIn(samplePoint);
 #ifdef G4VERBOSE
-          if(( fCheck ) && ( fVerbose == 1 ))
+          if( fCheck )
           {
-            G4cout << "*** G4VoxelNavigation::ComputeStep(): ***" << G4endl
-                   << "    Invoked DistanceToIn(p) for daughter solid: "
-                   << sampleSolid->GetName()
-                   << ". Solid replied: " << sampleSafety << G4endl
-                   << "    For local point p: " << samplePoint
-                   << ", to be considered as 'daughter safety'." << G4endl;
+            fLogger->PrintDaughterLog(sampleSolid,samplePoint,sampleSafety,0);
           }
 #endif
@@ -224,13 +178,8 @@
                      sampleSolid->DistanceToIn(samplePoint, sampleDirection);
 #ifdef G4VERBOSE
-            if(( fCheck ) && ( fVerbose == 1 ))
+            if( fCheck )
             {
-              G4cout << "*** G4VoxelNavigation::ComputeStep(): ***" << G4endl
-                     << "    Invoked DistanceToIn(p,v) for daughter solid: "
-                     << sampleSolid->GetName()
-                     << ". Solid replied: " << sampleStep << G4endl
-                     << "    For local point p: " << samplePoint << G4endl
-                     << "    Direction v: " << sampleDirection
-                     << ", to be considered as 'daughter step'." << G4endl;
+              fLogger->PrintDaughterLog(sampleSolid, samplePoint,
+                                        sampleSafety, sampleStep);
             }
 #endif
@@ -247,96 +196,8 @@
               // candidate.
 
-              if ( ( fCheck ) && ( sampleStep < kInfinity ) )
+              if ( fCheck )
               {
-                G4ThreeVector intersectionPoint;
-                intersectionPoint= samplePoint + sampleStep * sampleDirection;
-                EInside insideIntPt= sampleSolid->Inside(intersectionPoint); 
-                G4String solidResponse = "-kInside-";
-                if (insideIntPt == kOutside)
-                  { solidResponse = "-kOutside-"; }
-                else if (insideIntPt == kSurface)
-                  { solidResponse = "-kSurface-"; }
-                if( fVerbose == 1 )
-                {
-                  G4cout << "*** G4VoxelNavigation::ComputeStep(): ***"<<G4endl
-                         << "    Invoked Inside() for solid: "
-                         << sampleSolid->GetName()
-                         << ". Solid replied: " << solidResponse << G4endl
-                         << "    For point p: " << intersectionPoint
-                         << ", considered as 'intersection' point." << G4endl;
-                }
-                G4double safetyIn= -1, safetyOut= -1;  //  Set to invalid values
-                G4double newDistIn= -1,  newDistOut= -1;
-                if( insideIntPt != kInside )
-                {
-                  safetyIn= sampleSolid->DistanceToIn(intersectionPoint);
-                  newDistIn= sampleSolid->DistanceToIn(intersectionPoint,
-                                                       sampleDirection);
-                }
-                if( insideIntPt != kOutside )
-                {
-                  safetyOut= sampleSolid->DistanceToOut(intersectionPoint);
-                  newDistOut= sampleSolid->DistanceToOut(intersectionPoint,
-                                                         sampleDirection);
-                }
-                if( insideIntPt != kSurface )
-                {
-                  G4int oldcoutPrec = G4cout.precision(16); 
-                  G4cout << "WARNING - G4VoxelNavigation::ComputeStep()"
-                         << G4endl
-                         << "          Inaccurate solid DistanceToIn"
-                         << " for solid " << sampleSolid->GetName() << G4endl;
-                  G4cout << "          Solid gave DistanceToIn = "
-                         << sampleStep << " yet returns " << solidResponse
-                         << " for this point !" << G4endl; 
-                  G4cout << "          Point = " << intersectionPoint << G4endl;
-                  G4cout << "          Safety values: " << G4endl;
-                  if ( insideIntPt != kInside )
-                  {
-                    G4cout << "          DistanceToIn(p)  = " << safetyIn
-                           << G4endl;
-                  }
-                  if ( insideIntPt != kOutside )
-                  {
-                    G4cout << "          DistanceToOut(p) = " << safetyOut
-                           << G4endl;
-                  }
-                  G4Exception("G4VoxelNavigation::ComputeStep()", 
-                              "InaccurateDistanceToIn", JustWarning,
-                              "Conflicting response from Solid.");
-                  G4cout.precision(oldcoutPrec);
-                }
-                else
-                {  
-                  // If it is on the surface, *ensure* that either DistanceToIn
-                  // or DistanceToOut returns a finite value ( >= Tolerance).
-                  //
-                  if( std::max( newDistIn, newDistOut ) <= kCarTolerance )
-                  { 
-                    G4cout << "ERROR - G4VoxelNavigation::ComputeStep()"
-                       << G4endl
-                       << "  Identified point for which the solid " 
-                       << sampleSolid->GetName() << G4endl
-                       << "  has MAJOR problem:  " << G4endl
-                       << "  --> Both DistanceToIn(p,v) and DistanceToOut(p,v) "
-                       << "return Zero, an equivalent value or negative value."
-                       << G4endl; 
-                    G4cout << "    Solid: " << sampleSolid << G4endl;
-                    G4cout << "    Point p= " << intersectionPoint << G4endl;
-                    G4cout << "    Direction v= " << sampleDirection << G4endl;
-                    G4cout << "    DistanceToIn(p,v)     = " << newDistIn
-                           << G4endl;
-                    G4cout << "    DistanceToOut(p,v,..) = " << newDistOut
-                           << G4endl;
-                    G4cout << "    Safety values: " << G4endl;
-                    G4cout << "      DistanceToIn(p)  = " << safetyIn
-                           << G4endl;
-                    G4cout << "      DistanceToOut(p) = " << safetyOut
-                           << G4endl;
-                    G4Exception("G4VoxelNavigation::ComputeStep()", 
-                              "DistanceToInAndOutAreZero", FatalException,
-                              "Zero from both Solid DistanceIn and Out(p,v).");
-                  }
-                }
+                fLogger->AlongComputeStepLog (sampleSolid, samplePoint,
+                  sampleDirection, localDirection, sampleSafety, sampleStep);
               }
 #endif
@@ -378,31 +239,6 @@
           if ( fCheck )
           {
-            if(fVerbose == 1)
-            {
-              G4cout << "*** G4VoxelNavigation::ComputeStep(): ***" << G4endl
-                     << "    Invoked DistanceToOut(p,v,...) for mother solid: "
-                     << motherSolid->GetName()
-                     << ". Solid replied: " << motherStep << G4endl
-                     << "    For local point p: " << localPoint << G4endl
-                     << "    Direction v: " << localDirection
-                     << ", to be considered as 'mother step'." << G4endl;
-            }
-            if( ( motherStep < 0.0 ) || ( motherStep >= kInfinity) )
-            {
-              G4int oldPrOut= G4cout.precision(16); 
-              G4int oldPrErr= G4cerr.precision(16);
-              G4cerr << "ERROR - G4VoxelNavigation::ComputeStep()" << G4endl
-                     << "        Problem in Navigation"  << G4endl
-                     << "        Point (local coordinates): "
-                     << localPoint << G4endl
-                     << "        Local Direction: " << localDirection << G4endl
-                     << "        Solid: " << motherSolid->GetName() << G4endl; 
-              motherSolid->DumpInfo();
-              G4Exception("G4VoxelNavigation::ComputeStep()",
-                          "PointOutsideCurrentVolume", FatalException,
-                          "Current point is outside the current solid !");
-              G4cout.precision(oldPrOut);
-              G4cerr.precision(oldPrErr);
-            }
+            fLogger->PostComputeStepLog(motherSolid, localPoint, localDirection,
+                                        motherStep, motherSafety);
           }
 #endif
@@ -480,13 +316,13 @@
   }
   else if (maxCurNodeNoDelta < minCurNodeNoDelta)
-       {
-         voxelSafety = maxCurNodeNoDelta*curNodeWidth;
-         voxelSafety += maxCurCommonDelta;
-        }
-        else    // (maxCurNodeNoDelta == minCurNodeNoDelta)
-        {
-          voxelSafety = minCurNodeNoDelta*curNodeWidth;
-          voxelSafety += std::min(minCurCommonDelta,maxCurCommonDelta);
-        }
+  {
+    voxelSafety = maxCurNodeNoDelta*curNodeWidth;
+    voxelSafety += maxCurCommonDelta;
+  }
+  else    // (maxCurNodeNoDelta == minCurNodeNoDelta)
+  {
+    voxelSafety = minCurNodeNoDelta*curNodeWidth;
+    voxelSafety += std::min(minCurCommonDelta,maxCurCommonDelta);
+  }
 
   // Compute isotropic safety to boundaries of previous levels
@@ -552,4 +388,6 @@
   
   G4double currentDistance = currentStep;
+  static const G4double sigma = 0.5*G4GeometryTolerance::GetInstance()
+                                    ->GetSurfaceTolerance();
 
   // Determine if end of Step within current voxel
@@ -567,8 +405,8 @@
     minVal = workMinExtent+workNodeNo*workNodeWidth;
 
-    if ( minVal<=workCoord+kCarTolerance*0.5 )
+    if ( minVal<=workCoord+sigma )
     {
       maxVal = minVal+workNodeWidth;
-      if ( maxVal<=workCoord-kCarTolerance*0.5 )
+      if ( maxVal<=workCoord-sigma )
       {
         // Must consider next voxel
@@ -607,9 +445,9 @@
     minVal = workMinExtent+fVoxelNode->GetMinEquivalentSliceNo()*workNodeWidth;
 
-    if ( minVal<=workCoord+kCarTolerance*0.5 )
+    if ( minVal<=workCoord+sigma )
     {
       maxVal = workMinExtent+(fVoxelNode->GetMaxEquivalentSliceNo()+1)
                             *workNodeWidth;
-      if ( maxVal<=workCoord-kCarTolerance*0.5 )
+      if ( maxVal<=workCoord-sigma )
       {
         newNodeNo = fVoxelNode->GetMaxEquivalentSliceNo()+1;
@@ -710,5 +548,5 @@
 G4VoxelNavigation::ComputeSafety(const G4ThreeVector& localPoint,
                                  const G4NavigationHistory& history,
-                                 const G4double )
+                                 const G4double       maxLength)
 {
   G4VPhysicalVolume *motherPhysical, *samplePhysical;
@@ -725,4 +563,9 @@
   motherSolid = motherLogical->GetSolid();
 
+  if( fBestSafety )
+  { 
+    return fpVoxelSafety->ComputeSafety( localPoint,*motherPhysical,maxLength );
+  }
+
   //
   // Compute mother safety
@@ -733,12 +576,7 @@
 
 #ifdef G4VERBOSE
-  if(( fCheck ) && ( fVerbose == 1 ))
-  {
-    G4cout << "*** G4VoxelNavigation::ComputeSafety(): ***" << G4endl
-           << "    Invoked DistanceToOut(p) for mother solid: "
-           << motherSolid->GetName()
-           << ". Solid replied: " << motherSafety << G4endl
-           << "    For local point p: " << localPoint
-           << ", to be considered as 'mother safety'." << G4endl;
+  if( fCheck )
+  {
+    fLogger->ComputeSafetyLog (motherSolid, localPoint, motherSafety, true);
   }
 #endif
@@ -772,12 +610,7 @@
     }
 #ifdef G4VERBOSE
-    if(( fCheck ) && ( fVerbose == 1 ))
-    {
-      G4cout << "*** G4VoxelNavigation::ComputeSafety(): ***" << G4endl
-             << "    Invoked DistanceToIn(p) for daughter solid: "
-             << sampleSolid->GetName()
-             << ". Solid replied: " << sampleSafety << G4endl
-             << "    For local point p: " << samplePoint
-             << ", to be considered as 'daughter safety'." << G4endl;
+    if( fCheck )
+    {
+      fLogger->ComputeSafetyLog (sampleSolid,samplePoint,sampleSafety,false);
     }
 #endif
@@ -790,2 +623,12 @@
   return ourSafety;
 }
+
+// ********************************************************************
+// SetVerboseLevel
+// ********************************************************************
+//
+void  G4VoxelNavigation::SetVerboseLevel(G4int level)
+{
+  if( fLogger )       fLogger->SetVerboseLevel(level);
+  if( fpVoxelSafety)  fpVoxelSafety->SetVerboseLevel( level ); 
+}
Index: trunk/source/geometry/navigation/test/ApproxEqual.hh
===================================================================
--- trunk/source/geometry/navigation/test/ApproxEqual.hh	(revision 1337)
+++ trunk/source/geometry/navigation/test/ApproxEqual.hh	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: ApproxEqual.hh,v 1.4 2006/06/29 18:37:15 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 
Index: trunk/source/geometry/navigation/test/MyMultiNavigator.hh
===================================================================
--- trunk/source/geometry/navigation/test/MyMultiNavigator.hh	(revision 1337)
+++ trunk/source/geometry/navigation/test/MyMultiNavigator.hh	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: MyMultiNavigator.hh,v 1.1 2006/11/11 01:35:38 japost Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Class to help test Multi-navigator geometry 
Index: trunk/source/geometry/navigation/test/testG4MultiNavigator1.cc
===================================================================
--- trunk/source/geometry/navigation/test/testG4MultiNavigator1.cc	(revision 1337)
+++ trunk/source/geometry/navigation/test/testG4MultiNavigator1.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: testG4MultiNavigator1.cc,v 1.1 2006/11/11 01:35:38 japost Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // 
Index: trunk/source/geometry/navigation/test/testG4Navigator1.cc
===================================================================
--- trunk/source/geometry/navigation/test/testG4Navigator1.cc	(revision 1337)
+++ trunk/source/geometry/navigation/test/testG4Navigator1.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: testG4Navigator1.cc,v 1.5 2006/06/29 18:37:17 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // 
Index: trunk/source/geometry/navigation/test/testG4Navigator2.cc
===================================================================
--- trunk/source/geometry/navigation/test/testG4Navigator2.cc	(revision 1337)
+++ trunk/source/geometry/navigation/test/testG4Navigator2.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: testG4Navigator2.cc,v 1.6 2007/03/23 18:33:08 japost Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // 
Index: trunk/source/geometry/navigation/test/testG4Navigator3.cc
===================================================================
--- trunk/source/geometry/navigation/test/testG4Navigator3.cc	(revision 1337)
+++ trunk/source/geometry/navigation/test/testG4Navigator3.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: testG4Navigator3.cc,v 1.5 2006/06/29 18:37:21 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // 
Index: trunk/source/geometry/navigation/test/testG4Navigator4.cc
===================================================================
--- trunk/source/geometry/navigation/test/testG4Navigator4.cc	(revision 1337)
+++ trunk/source/geometry/navigation/test/testG4Navigator4.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: testG4Navigator4.cc,v 1.5 2006/06/29 18:37:23 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // 
Index: trunk/source/geometry/navigation/test/testG4Navigator5.cc
===================================================================
--- trunk/source/geometry/navigation/test/testG4Navigator5.cc	(revision 1337)
+++ trunk/source/geometry/navigation/test/testG4Navigator5.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: testG4Navigator5.cc,v 1.6 2006/06/29 18:37:26 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // 
Index: trunk/source/geometry/navigation/test/testG4Navigator6.cc
===================================================================
--- trunk/source/geometry/navigation/test/testG4Navigator6.cc	(revision 1337)
+++ trunk/source/geometry/navigation/test/testG4Navigator6.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: testG4Navigator6.cc,v 1.5 2006/06/29 18:37:28 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // 
Index: trunk/source/geometry/navigation/test/testG4NestedParameterisedNav.cc
===================================================================
--- trunk/source/geometry/navigation/test/testG4NestedParameterisedNav.cc	(revision 1337)
+++ trunk/source/geometry/navigation/test/testG4NestedParameterisedNav.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: testG4NestedParameterisedNav.cc,v 1.6 2006/06/29 18:37:30 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // 
Index: trunk/source/geometry/navigation/test/testG4PathFinder.cc
===================================================================
--- trunk/source/geometry/navigation/test/testG4PathFinder.cc	(revision 1337)
+++ trunk/source/geometry/navigation/test/testG4PathFinder.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: testG4PathFinder.cc,v 1.8 2007/02/13 16:15:34 japost Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $ 
+// GEANT4 tag $Name: geant4-09-04-ref-00 $ 
 //
 // 
